/*	This tests a bug that's been around for a while.  At the moment, an
 *	an expression of the form array[a..b] = scalar evaluates to something
 *	totally meaningless: an array that begins at the first assigned index and
 *	has a length equal to the length of the original array.  It should be
 *	evaluating to the slice to which the assignment was made.
 *
 *	Category: run
 */
int main() {
	int[] piece = new int[6];
	int[] item;

	item = piece[2..5] = 3;
	assert (item is piece[2..5]);

	piece[3] = 5;

	assert (piece[0] == 0);
	assert (piece[1] == 0);
	assert (piece[2] == 3);
	assert (piece[3] == 5);
	assert (piece[4] == 3);
	assert (piece[5] == 0);
	assert (item.length == 3);
	assert (item[0] == 3);
	assert (item[1] == 5);
	assert (item[2] == 3);

	return 0;
}
