/*	This tests the inheritance of in contracts.
 *	See http://www.digitalmars.com/d/dbc.html section
 *	"In, Out and Inheritance".
 *
 *	This tests the three cases where the combination of new and inherited
 *	contracts makes the method call valid:
 *	- Passes only Derived.func's in block
 *	- Passes both Derived.func's and Base.func's in blocks
 *	- Fails Derived.func's in block, in which case falls back to the
 *	  Base.func contract, which passes it as valid.
 *
 *	Category: run
 */
class Base {
	void func(int x)
	in {
		assert (x >= 10);
	}
	body {}
}


class Derived : Base {
	override void func(int x)
	in {
		assert (x % 10 >= 5);
	}
	body {}
}


int main() {
	Base o = new Derived;

	o.func(5);
	o.func(15);
	o.func(10);

	return 0;
}
