/*	This tests the inheritance of in contracts.
 *	See http://www.digitalmars.com/d/dbc.html section
 *	"In, Out and Inheritance".
 *
 *	The spec isn't crystal clear on what should happen if a method of a base
 *	class defines an in contract, but its override doesn't.  Should the base
 *	contract pass through unchanged, or should not specifying a contract
 *	cause the precondition to be widened such that every call is legal?
 *
 *	Category: undefined
 */
class Base {
	void func(int x)
	in {
		assert (x >= 10);
	}
	body {}
}


class Derived : Base {
	override void func(int x) {}
}


int main() {
	Base o = new Derived;

	o.func(10);
	o.func(5);

	return 0;
}
