/*	This tests the inheritance of out contracts.
 *	See http://www.digitalmars.com/d/dbc.html section
 *	"In, Out and Inheritance".
 *
 *	This test is for a compliant function, i.e. one that obeys its own out
 *	contract and that which is inherited.
 *
 *	Category: run
 */
class Base {
	int func()
	out (result) {
		assert (result >= 10);
	}
	body {
		return 20;
	}
}


class Derived : Base {
	override int func()
	out (result) {
		assert (result <= 15);
	}
	body {
		return 12;
	}
}


int main() {
	Derived o = new Derived;

	assert (o.func() == 12);

	return 0;
}
